%
%  untitled
%
%  Created by Sebastien Gilles on 2013-05-16.
%  Copyright (c) 2013 __MyCompanyName__. All rights reserved.
%
\documentclass[]{article}

% Use utf-8 encoding for foreign characters
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}

% Setup for fullpage use
\usepackage{fullpage}

% Uncomment some of the following if you use the features
%
% Running Headers and footers
%\usepackage{fancyhdr}

% Multipart figures
%\usepackage{subfigure}

% More symbols
%\usepackage{amsmath}
%\usepackage{amssymb}
%\usepackage{latexsym}

% Surround parts of graphics with box
\usepackage{boxedminipage}

% Package for including code in the document
\usepackage{listings}
\usepackage{verbatim}
\usepackage{color}
\usepackage{indentfirst}

% Package for biblio
\usepackage[authoryear,round,comma]{natbib}

\definecolor{mygreen}{rgb}{0,0.6,0}
\definecolor{mygray}{rgb}{0.5,0.5,0.5}
\definecolor{mymauve}{rgb}{0.58,0,0.82}

\lstset{ %
  backgroundcolor=\color{white},   % choose the background color; you must add \usepackage{color} or \usepackage{xcolor}
  basicstyle=\footnotesize,        % the size of the fonts that are used for the code
  breakatwhitespace=false,         % sets if automatic breaks should only happen at whitespace
  breaklines=true,                 % sets automatic line breaking
  captionpos=b,                    % sets the caption-position to bottom
  commentstyle=\color{mygreen},    % comment style
  deletekeywords={...},            % if you want to delete keywords from the given language
  escapeinside={\%*}{*)},          % if you want to add LaTeX within your code
  extendedchars=true,              % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
  frame=single,                    % adds a frame around the code
  keepspaces=true,                 % keeps spaces in text, useful for keeping indentation of code (possibly needs columns=flexible)
  keywordstyle=\color{blue},       % keyword style
  language=C++,                    % the language of the code
  morekeywords={*,...},            % if you want to add more keywords to the set
  numbers=none,                    % where to put the line-numbers; possible values are (none, left, right)
  numbersep=5pt,                   % how far the line-numbers are from the code
  numberstyle=\tiny\color{mygray}, % the style that is used for the line-numbers
  rulecolor=\color{black},         % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. comments (green here))
  showspaces=false,                % show spaces everywhere adding particular underscores; it overrides 'showstringspaces'
  showstringspaces=false,          % underline spaces within strings only
  showtabs=false,                  % show tabs within strings adding particular underscores
  stepnumber=2,                    % the step between two line-numbers. If it's 1, each line will be numbered
  stringstyle=\color{mymauve},     % string literal style
  tabsize=2,                       % sets default tabsize to 2 spaces
  title=\lstname                   % show the filename of files included with \lstinputlisting; also try caption instead of title
}





% If you want to generate a toc for each chapter (use with book)
\usepackage{minitoc}

% This is now the recommended way for checking for PDFLaTeX:
\usepackage{ifpdf}

%\newif\ifpdf
%\ifx\pdfoutput\undefined
%\pdffalse % we are not running PDFLaTeX
%\else
%\pdfoutput=1 % we are running PDFLaTeX
%\pdftrue
%\fi

\ifpdf
\usepackage[pdftex]{graphicx}
\else
\usepackage{graphicx}
\fi



\title{Coding standards: exceptions}
\author{Sébastien Gilles}

%\date{2013-05-23}

\begin{document}
	
\newcommand{\refchapter}[1]{chapter \ref{#1}}
\newcommand{\refsection}[1]{section \ref{#1}}
\newcommand{\refcode}[1]{code excerpt \ref{#1}}
\newcommand{\path}[1]{\textit{#1}}
\newcommand{\code}[1]{\textit{#1}}
\renewcommand{\lstlistingname}{Code excerpt}

\ifpdf
\DeclareGraphicsExtensions{.pdf, .jpg, .tif}
\else
\DeclareGraphicsExtensions{.eps, .jpg}
\fi

\maketitle

\section{Exception class}

HappyHeart defines its own exception class in the library \lstinline{Utilities}, because all the code should have access to it\footnote{(it is not the case for instance of the \lstinline{Core} library, because \lstinline{Utilities} does not depend on it.}.

This class derives from \lstinline{std::exception}, as doing so is an healthy practice to follow. However, its implementation has been enriched on two points:

\begin{itemize}
    \item The \lstinline{what()} virtual method now calls an underlying \lstinline{std::string}. Hence we get rid of annoying lifetime issues that arise frequently with the original interface of \lstinline{std::exception}.
    \item The file and line where the exception is thrown are now required in the constructor. The reason of this is that the debugger does not always give away this information, or that in parallel processing there is no debugger at all\dots
\end{itemize}

Absolutely all the exceptions defined within HappyHeart derive from this class; often through inheritance (even if in some cases there is a direct call to this \lstinline{Exception} class).

\section{Location and namespaces of HappyHeart exceptions}

We will consider below the case of \lstinline{GeometricElement}-related classes to explain where the exceptions are defined (both in the filesystem and in the code namespaces).

\begin{itemize}
    \item In the folder where there are the sources of \lstinline{GeometricElement}, an \textit{Exceptions} folder is created.
    \item In this folder, the \lstinline{GeometricElement}-related exception classes are put in a file named \textit{GeometricElement}\footnote{e.g. the same name as the class for which the exceptions are created.}.
    \item The enclosing namespace of the \lstinline{GeometricElement}-related exceptions is the same as the one of \lstinline{GeometricElement}, to which two new layers are added:
    \begin{itemize}
        \item A namespace named \lstinline{ExceptionNS}.
        \item A namespace named \lstinline{GeometricElement}
    \end{itemize}
    For instance \lstinline{GeometricElement} is in the namespace \lstinline{HappyHeart}, so one of its exception named \lstinline{FormatNotSupported} will be in \lstinline{HappyHeart::ExceptionNS::GeometricElement} namespace.
    
\end{itemize}






\end{document}